Preserve permissions on /etc/passwd and shadow when modifying them.
diff -uNr Linux-PAM-0.75/modules/pam_unix/pam_unix_passwd.c Linux-PAM-0.75/modules/pam_unix/pam_unix_passwd.c
--- Linux-PAM-0.75/modules/pam_unix/pam_unix_passwd.c	Sun Feb 11 01:33:53 2001
+++ Linux-PAM-0.75/modules/pam_unix/pam_unix_passwd.c	Tue Jul 10 00:14:23 2001
@@ -331,6 +331,7 @@
 static int _update_passwd(const char *forwho, const char *towhat)
 {
 	struct passwd *tmpent = NULL;
+	struct stat st;
 	FILE *pwfile, *opwfile;
 	int retval = 0;
 	int err = 0;
@@ -342,8 +343,13 @@
 	opwfile = fopen("/etc/passwd", "r");
 	if (pwfile == NULL || opwfile == NULL)
 		return PAM_AUTHTOK_ERR;
-	chown(PW_TMPFILE, 0, 0);
-	chmod(PW_TMPFILE, 0644);
+	if(fstat(fileno(pwfile), &st) == -1) {
+		chown(PW_TMPFILE, 0, 0);
+		chmod(PW_TMPFILE, 0644);
+	} else {
+		chown(PW_TMPFILE, st.st_uid, st.st_gid);
+		chmod(PW_TMPFILE, st.st_mode);
+	}
 	tmpent = fgetpwent(opwfile);
 	while (tmpent) {
 		if (!strcmp(tmpent->pw_name, forwho)) {
@@ -377,6 +383,7 @@
 static int _update_shadow(const char *forwho, char *towhat)
 {
 	struct spwd *spwdent = NULL, *stmpent = NULL;
+	struct stat st;
 	FILE *pwfile, *opwfile;
 	int retval = 0;
 	int err = 0;
@@ -391,8 +398,13 @@
 	opwfile = fopen("/etc/shadow", "r");
 	if (pwfile == NULL || opwfile == NULL)
 		return PAM_AUTHTOK_ERR;
-	chown(SH_TMPFILE, 0, 0);
-	chmod(SH_TMPFILE, 0600);
+	if(fstat(fileno(opwfile), &st) == -1) {
+		chown(SH_TMPFILE, 0, 0);
+		chmod(SH_TMPFILE, 0600);
+	} else {
+		chown(SH_TMPFILE, st.st_uid, st.st_gid);
+		chmod(SH_TMPFILE, st.st_mode);
+	}
 	stmpent = fgetspent(opwfile);
 	while (stmpent) {
 		if (!strcmp(stmpent->sp_namp, forwho)) {
